## candle 1.1.9

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(Candle)

# set(CMAKE_VERBOSE_MAKEFILE ON)

# instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)

# create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -msse3")

if(APPLE)
    add_compile_definitions(Q_OS_MAC)
endif()
add_compile_definitions(APP_VERSION="1.1.9")
add_compile_definitions(QT_NO_DEBUG)

find_package(Qt5 COMPONENTS Core Widgets OpenGL SerialPort REQUIRED)

include_directories(${PROJECT_SOURCE_DIR})

file(GLOB SRC_FILES ${PROJECT_SOURCE_DIR}/*.cpp
                    ${PROJECT_SOURCE_DIR}/drawers/*.cpp
                    ${PROJECT_SOURCE_DIR}/parser/*.cpp
                    ${PROJECT_SOURCE_DIR}/widgets/*.cpp
                    ${PROJECT_SOURCE_DIR}/tables/*.cpp
                    )

qt5_add_resources(SHADER_RSC 
    ${PROJECT_SOURCE_DIR}/shaders.qrc
    ${PROJECT_SOURCE_DIR}/images.qrc
    ${PROJECT_SOURCE_DIR}/fonts.qrc
    )

if(APPLE)
    add_executable(Candle MACOSX_BUNDLE ${SRC_FILES} ${SHADER_RSC})
    set_target_properties(Candle PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/Info.plist)
else()
    add_executable(Candle ${SRC_FILES} ${SHADER_RSC})
endif()

target_link_libraries(Candle
    Qt5::Core
    Qt5::Widgets
    Qt5::OpenGL
    Qt5::Gui
    Qt5::SerialPort
    )

=== debian/changelog ===
candle (1.1.9-5) unstable; urgency=medium

  * Add includes to fix build on armhf.

 -- Keith Packard <keithp@keithp.com>  Fri, 03 Oct 2025 12:33:52 -0700

candle (1.1.9-4) unstable; urgency=medium

  * Remove -mss3 compile option. Closes: #1117129.

 -- Keith Packard <keithp@keithp.com>  Fri, 03 Oct 2025 09:06:20 -0700

candle (1.1.9-3) unstable; urgency=medium

  * Reset interpreter to 0,0,0 instead of nan,nan,nan

 -- Keith Packard <keithp@keithp.com>  Mon, 16 Jun 2025 21:17:39 -0700

candle (1.1.9-2) unstable; urgency=medium

  * Fix settings file location
  * Use defaults when no settings are found
  * Allow any filename on command line

 -- Keith Packard <keithp@keithp.com>  Mon, 09 Jun 2025 16:25:48 -0700

candle (1.1.9-1) unstable; urgency=medium

  * Initial release.

 -- Keith Packard <keithp@keithp.com>  Sun, 08 Jun 2025 21:17:52 -0700

=== debian/control ===
Source: candle
Section: graphics
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Rules-Requires-Root: no
Build-Depends: cmake,
 libqt5opengl5-dev,
 libqt5serialport5-dev,
 qtbase5-dev,
 dh-exec,
 debhelper-compat (= 13),
Standards-Version: 4.7.2
Homepage: https://github.com/Denvi/Candle
Vcs-Browser: https://github.com/Denvi/Candle
Vcs-Git: https://github.com/Denvi/Candle

Package: candle
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: GRBL controller application with G-Code visualizer
 Candle supports controlling GRBL-based cnc-machine via
 console commands, buttons on form, numpad; monitoring cnc-machine
 state; loading, editing, saving and sending of G-code files to
 cnc-machine; and visualizing G-code files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --sourcedirectory=src --builddirectory=build

## candle api-0.0.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(candle_api)

option(CANDLE_API_SHARED "Build Shared Library" OFF)
option(CANDLE_API_BUILD_EXAMPLES "Build Example Applications" OFF)
option(CANDLE_API_BUILD_PYBIND11 "Build Python Extension" OFF)
option(CANDLE_API_BUILD_NODE_JS "Build Node.js Extension" OFF)
option(CANDLE_API_TINYCTHREADS "Build with TinyCThread" OFF)

add_subdirectory(candle_api)

if (CANDLE_API_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if (CANDLE_API_BUILD_PYBIND11)
    add_subdirectory(candle_api_pybind11)
endif ()

if (CANDLE_API_BUILD_NODE_JS)
    add_subdirectory(candle_api_js)
endif ()

=== candle_api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(candle_api_library)

set(LIBUSB_BUILD_SHARED_LIBS OFF)
set(LIBUSB_BUILD_TESTING OFF)
set(LIBUSB_BUILD_EXAMPLES OFF)
set(LIBUSB_INSTALL_TARGETS OFF)
set(LIBUSB_TARGETS_INCLUDE_USING_SYSTEM ON)
set(LIBUSB_ENABLE_LOGGING OFF)
set(LIBUSB_ENABLE_DEBUG_LOGGING OFF)
add_subdirectory(libusb-cmake)

if (NOT WIN32)
    set_target_properties(usb-1.0 PROPERTIES POSITION_INDEPENDENT_CODE ON)
endif ()

aux_source_directory(src candle_api_srcs)

if (CANDLE_API_SHARED)
    add_library(candle_api SHARED ${candle_api_srcs})
    set_target_properties(candle_api PROPERTIES POSITION_INDEPENDENT_CODE ON)
else ()
    add_library(candle_api STATIC ${candle_api_srcs})
endif ()

target_include_directories(candle_api PUBLIC include)
target_include_directories(candle_api PRIVATE src)
target_link_libraries(candle_api PRIVATE usb-1.0)

if (CANDLE_API_TINYCTHREADS)
    target_sources(candle_api PRIVATE tinycthread/tinycthread.c)
    target_include_directories(candle_api PRIVATE tinycthread)
    set_target_properties(candle_api PROPERTIES POSITION_INDEPENDENT_CODE ON)
    target_compile_definitions(candle_api PRIVATE USING_TINYCTHREADS)
else ()
    set_target_properties(candle_api PROPERTIES C_STANDARD 11)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(candle_api PRIVATE -Wall -Wextra -Wpedantic -Werror)
endif()

if (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    target_compile_options(candle_api PRIVATE /experimental:c11atomics)
endif()

=== candle_api_js/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)
project(candle-js)

add_library(${PROJECT_NAME} SHARED ${CMAKE_JS_SRC} "candle_api.cpp")
target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_JS_INC})
set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "" SUFFIX ".node")
target_link_libraries(${PROJECT_NAME} ${CMAKE_JS_LIB} candle_api)
target_compile_definitions(${PROJECT_NAME} PRIVATE NAPI_VERSION=6)

if(MSVC AND CMAKE_JS_NODELIB_DEF AND CMAKE_JS_NODELIB_TARGET)
    execute_process(COMMAND ${CMAKE_AR} /def:${CMAKE_JS_NODELIB_DEF} /out:${CMAKE_JS_NODELIB_TARGET} ${CMAKE_STATIC_LINKER_FLAGS})
endif()

execute_process(COMMAND node -p "require('node-addon-api').include"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE NODE_ADDON_API_DIR
)
string(REGEX REPLACE "[\r\n\"]" "" NODE_ADDON_API_DIR ${NODE_ADDON_API_DIR})

target_include_directories(${PROJECT_NAME} PRIVATE ${NODE_ADDON_API_DIR})

=== candle_api_pybind11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(candle_api_pybind11 CXX)

add_subdirectory(pybind11)

pybind11_add_module(candle_api_pybind11 src/bindings.cpp)
target_link_libraries(candle_api_pybind11 PRIVATE candle_api)
set_target_properties(candle_api_pybind11 PROPERTIES OUTPUT_NAME bindings CXX_STANDARD 17)

=== examples/CMakeLists.txt ===
project(examples)

file(GLOB EXAMPLE_DIRS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*)

foreach(EXAMPLE ${EXAMPLE_DIRS})
    if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE})
        if (NOT ${EXAMPLE} STREQUAL "python")
            add_subdirectory(${EXAMPLE})
        endif ()
    endif()
endforeach()

=== candle_api/libusb-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

get_filename_component(LIBUSB_ROOT "libusb/libusb" ABSOLUTE)

# Get the version information from version.h ignoring the nano version as it appears in version_nano.h and so we need it?
file(READ "${LIBUSB_ROOT}/version.h" VERSIONHEADERDATA)
string(REGEX MATCH "#define LIBUSB_MAJOR ([0-9]*)" _ ${VERSIONHEADERDATA})
set(LIBUSB_VERSION_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define LIBUSB_MINOR ([0-9]*)" _ ${VERSIONHEADERDATA})
set(LIBUSB_VERSION_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "#define LIBUSB_MICRO ([0-9]*)" _ ${VERSIONHEADERDATA})
set(LIBUSB_VERSION_MICRO ${CMAKE_MATCH_1})
set(LIBUSB_VERSION "${LIBUSB_VERSION_MAJOR}.${LIBUSB_VERSION_MINOR}.${LIBUSB_VERSION_MICRO}")

project(usb-1.0
    DESCRIPTION "A cross-platform library to access USB devices"
    VERSION ${LIBUSB_VERSION}
    LANGUAGES C
)
if(EMSCRIPTEN)
    set(CMAKE_CXX_STANDARD 20)
    enable_language(CXX)
endif()

# This function generates all the local variables what end up getting written to config.
# We use a function as any vars set in this context don't mess with the rest of the file.
# e.g. Logging LIBUSB_ENABLE_LOGGING mapps to ENABLE_LOGGING in the config, keeps it clean
function(generate_config_file)
    include(CheckIncludeFiles)
    include(CheckFunctionExists)
    include(CheckSymbolExists)
    include(CheckStructHasMember)
    include(CheckCCompilerFlag)

    check_function_exists(clock_gettime             HAVE_CLOCK_GETTIME)
    check_function_exists(pthread_condattr_setclock HAVE_PTHREAD_CONDATTR_SETCLOCK)
    check_function_exists(pthread_setname_np        HAVE_PTHREAD_SETNAME_NP)
    check_function_exists(pthread_threadid_np       HAVE_PTHREAD_THREADID_NP)
    check_function_exists(eventfd                   HAVE_EVENTFD)
    check_function_exists(pipe2                     HAVE_PIPE2)
    check_function_exists(syslog                    HAVE_SYSLOG)

    check_include_files(asm/types.h      HAVE_ASM_TYPES_H)
    check_include_files(sys/eventfd.h    HAVE_EVENTFD)
    check_include_files(string.h         HAVE_STRING_H)
    check_include_files(sys/time.h       HAVE_SYS_TIME_H)

    check_symbol_exists(timerfd_create  "sys/timerfd.h" HAVE_TIMERFD)
    check_symbol_exists(nfds_t  "poll.h" HAVE_NFDS_T)

    check_struct_has_member("struct timespec" tv_sec time.h HAVE_STRUCT_TIMESPEC)

    if(HAVE_VISIBILITY)
        set(DEFAULT_VISIBILITY "__attribute__((visibility(\"default\")))")
    else()
        set(DEFAULT_VISIBILITY "" )
    endif()

    # Set vars that will be written into the config file.
    if(WIN32)
        set(PLATFORM_WINDOWS 1)
    else()
        set(PLATFORM_POSIX 1)
    endif()

    if(LIBUSB_ENABLE_LOGGING)
        set(ENABLE_LOGGING ${LIBUSB_ENABLE_LOGGING})
    endif()
    if(LIBUSB_ENABLE_DEBUG_LOGGING)
        set(ENABLE_DEBUG_LOGGING ${LIBUSB_ENABLE_DEBUG_LOGGING})
    endif()

    if(CMAKE_C_COMPILER_ID MATCHES "Clang" OR CMAKE_C_COMPILER_ID STREQUAL "GNU")
        check_c_compiler_flag("-fvisibility=hidden" HAVE_VISIBILITY)
    endif()

    file(MAKE_DIRECTORY "${LIBUSB_GEN_INCLUDES}")
    if(NOT MSVC)
        set(_GNU_SOURCE TRUE)
    endif()
    configure_file(config.h.in "${LIBUSB_GEN_INCLUDES}/config.h" @ONLY)
endfunction()

if(BUILD_SHARED_LIBS)
    set(LIBUSB_BUILD_SHARED_LIBS_DEFAULT ON)
else()
    set(LIBUSB_BUILD_SHARED_LIBS_DEFAULT OFF)
endif()

option(LIBUSB_BUILD_SHARED_LIBS "Build Shared Libraries for libusb" ${LIBUSB_BUILD_SHARED_LIBS_DEFAULT})
option(LIBUSB_BUILD_TESTING "Build Tests" OFF)
if(LIBUSB_BUILD_TESTING)
    enable_testing()
endif()

option(LIBUSB_BUILD_EXAMPLES "Build Example Applications" OFF)

option(LIBUSB_INSTALL_TARGETS "Install libusb targets" ON)
option(LIBUSB_TARGETS_INCLUDE_USING_SYSTEM "Make targets include paths System" ON)

option(LIBUSB_ENABLE_LOGGING "Enable Logging" ON)
option(LIBUSB_ENABLE_DEBUG_LOGGING "Enable Debug Logging" OFF)
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    option(LIBUSB_ENABLE_UDEV "Enable udev backend for device enumeration" ON)
endif()

set(LIBUSB_GEN_INCLUDES "${CMAKE_CURRENT_BINARY_DIR}/gen_include")
generate_config_file()

if(LIBUSB_BUILD_SHARED_LIBS)
    add_library(usb-1.0 SHARED)
else()
    add_library(usb-1.0 STATIC)
endif()

set_target_properties(usb-1.0 PROPERTIES
    PREFIX lib # to be consistent with mainline libusb build system(s)
)

# common sources
target_sources(usb-1.0 PRIVATE
    "${LIBUSB_GEN_INCLUDES}/config.h"
    "${LIBUSB_ROOT}/core.c"
    "${LIBUSB_ROOT}/descriptor.c"
    "${LIBUSB_ROOT}/hotplug.c"
    "${LIBUSB_ROOT}/io.c"
    "${LIBUSB_ROOT}/libusb.h"
    "${LIBUSB_ROOT}/libusbi.h"
    "${LIBUSB_ROOT}/strerror.c"
    "${LIBUSB_ROOT}/sync.c"
    "${LIBUSB_ROOT}/version.h"
    "${LIBUSB_ROOT}/version_nano.h"
)
target_include_directories(usb-1.0
    PRIVATE
        "${LIBUSB_GEN_INCLUDES}"
        "${LIBUSB_ROOT}/os"
)

if (LIBUSB_TARGETS_INCLUDE_USING_SYSTEM)
    target_include_directories(usb-1.0 SYSTEM PUBLIC "${LIBUSB_ROOT}")
else()
    target_include_directories(usb-1.0 PUBLIC "${LIBUSB_ROOT}")
endif()

if(WIN32)
    target_sources(usb-1.0 PRIVATE
        "${LIBUSB_ROOT}/libusb-1.0.def"
        "${LIBUSB_ROOT}/os/events_windows.c"
        "${LIBUSB_ROOT}/os/events_windows.h"
        "${LIBUSB_ROOT}/os/threads_windows.c"
        "${LIBUSB_ROOT}/os/threads_windows.h"
        "${LIBUSB_ROOT}/os/windows_common.c"
        "${LIBUSB_ROOT}/os/windows_common.h"
        "${LIBUSB_ROOT}/os/windows_usbdk.c"
        "${LIBUSB_ROOT}/os/windows_usbdk.h"
        "${LIBUSB_ROOT}/os/windows_winusb.c"
        "${LIBUSB_ROOT}/os/windows_winusb.h"
        $<$<C_COMPILER_ID:MSVC>:${LIBUSB_ROOT}/libusb-1.0.rc>
    )
    target_compile_definitions(usb-1.0 PRIVATE $<$<C_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS=1>)
    target_link_libraries(usb-1.0 PRIVATE windowsapp)
else()
    # common POSIX/non-Windows sources
    target_sources(usb-1.0 PRIVATE
        "${LIBUSB_ROOT}/os/events_posix.c"
        "${LIBUSB_ROOT}/os/events_posix.h"
        "${LIBUSB_ROOT}/os/threads_posix.c"
        "${LIBUSB_ROOT}/os/threads_posix.h"
    )
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/linux_usbfs.c"
            "${LIBUSB_ROOT}/os/linux_usbfs.h"
        )
        if(LIBUSB_ENABLE_UDEV)
            target_sources(usb-1.0 PRIVATE
                "${LIBUSB_ROOT}/os/linux_udev.c"
            )
            target_link_libraries(usb-1.0 PRIVATE udev)
            target_compile_definitions(usb-1.0 PRIVATE HAVE_LIBUDEV=1)
        else()
            target_sources(usb-1.0 PRIVATE
                "${LIBUSB_ROOT}/os/linux_netlink.c"
            )
        endif()
        find_package(Threads REQUIRED)
        target_link_libraries(usb-1.0 PRIVATE Threads::Threads)
    elseif(ANDROID)
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/linux_netlink.c"
            "${LIBUSB_ROOT}/os/linux_usbfs.c"
            "${LIBUSB_ROOT}/os/linux_usbfs.h"
        )
        target_link_libraries(usb-1.0 PRIVATE android log)
    elseif(APPLE)
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/darwin_usb.c"
            "${LIBUSB_ROOT}/os/darwin_usb.h"
        )
        target_link_libraries(usb-1.0 PRIVATE
            "-framework Foundation"
            "-framework IOKit"
            "-framework Security"
        )
    elseif(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/netbsd_usb.c"
        )
    elseif(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/openbsd_usb.c"
        )
    elseif(EMSCRIPTEN)
        target_sources(usb-1.0 PRIVATE
            "${LIBUSB_ROOT}/os/emscripten_webusb.cpp"
        )
        target_compile_options(usb-1.0 PRIVATE -pthread)
    else()
        message(FATAL_ERROR "Unsupported target platform: ${CMAKE_SYSTEM_NAME}")
    endif()
endif()

if(LIBUSB_BUILD_TESTING)
    add_subdirectory(tests)
endif()

if(LIBUSB_BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(LIBUSB_INSTALL_TARGETS)
    install(TARGETS usb-1.0)
    install(FILES "${LIBUSB_ROOT}/libusb.h" DESTINATION "include/libusb-1.0")
endif()

=== examples/list_device/CMakeLists.txt ===
project(list_device)

add_executable(${PROJECT_NAME} main.c)
target_link_libraries(${PROJECT_NAME} candle_api)

=== examples/ping_pong/CMakeLists.txt ===
project(ping_pong)

add_executable(${PROJECT_NAME} main.c)
target_link_libraries(${PROJECT_NAME} candle_api)

=== examples/send_receive/CMakeLists.txt ===
project(send_receive)

add_executable(${PROJECT_NAME} main.c)
target_link_libraries(${PROJECT_NAME} candle_api)

=== examples/stress/CMakeLists.txt ===
project(stress)

add_executable(${PROJECT_NAME} main.c)
target_link_libraries(${PROJECT_NAME} candle_api)
set_target_properties(${PROJECT_NAME} PROPERTIES C_STANDARD 11)

=== examples/stress2/CMakeLists.txt ===
project(stress2)

add_executable(${PROJECT_NAME} main.c)
target_link_libraries(${PROJECT_NAME} candle_api)
set_target_properties(${PROJECT_NAME} PROPERTIES C_STANDARD 11)

=== candle_api/libusb-cmake/examples/CMakeLists.txt ===
project(examples
    VERSION ${LIBUSB_VERSION}
    LANGUAGES C
)

get_filename_component(EXAMPLES_ROOT "${LIBUSB_ROOT}/../examples" ABSOLUTE)

if(MSVC)
    add_library(getoptMSVC STATIC
        "${LIBUSB_ROOT}/../msvc/getopt/getopt.c"
        "${LIBUSB_ROOT}/../msvc/getopt/getopt.h"
        "${LIBUSB_ROOT}/../msvc/getopt/getopt1.c"
    )
    # Need to pass HAVE_CONFIG_H so getopt.h can load the config header
    target_compile_definitions(getoptMSVC PRIVATE HAVE_CONFIG_H)
    target_include_directories(getoptMSVC
        PUBLIC "${LIBUSB_ROOT}/../msvc/getopt/"
        PRIVATE "${LIBUSB_GEN_INCLUDES}"
    )
endif()

function(add_libusb_example TEST_NAME)
    set(SOURCES)
    foreach(SOURCE_NAME ${ARGN})
        list(APPEND SOURCES "${EXAMPLES_ROOT}/${SOURCE_NAME}")
    endforeach()
    add_executable("${TEST_NAME}" ${SOURCES})
    target_include_directories("${TEST_NAME}" PRIVATE "${LIBUSB_GEN_INCLUDES}")
    target_link_libraries("${TEST_NAME}" PRIVATE usb-1.0)
    target_compile_definitions("${TEST_NAME}" PRIVATE $<$<C_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS=1>)
endfunction()

add_libusb_example(listdevs "listdevs.c")

add_libusb_example(dpfp "dpfp.c")

add_libusb_example(hotplugtest "hotplugtest.c")

add_libusb_example(fxload
    "ezusb.c"
    "ezusb.h"
    "fxload.c"
)
target_link_libraries(fxload PRIVATE $<$<C_COMPILER_ID:MSVC>:getoptMSVC>)

add_libusb_example(testlibusb "testlibusb.c")

add_libusb_example(sam3u_benchmark "sam3u_benchmark.c")

add_libusb_example(xusb "xusb.c")
